Codeforces Round #467 (Div. 2)

A. Olympiad
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

The recent All-Berland Olympiad in Informatics featured n participants with each scoring a certain amount of points.

As the head of the programming committee, you are to determine the set of participants to be awarded with diplomas with respect to the following criteria:

  • At least one participant should get a diploma.
  • None of those with score equal to zero should get awarded.
  • When someone is awarded, all participants with score not less than his score should also be awarded.

Determine the number of ways to choose a subset of participants that will receive the diplomas.

Input

The first line contains a single integer n (1 ≤ n ≤ 100) — the number of participants.

The next line contains a sequence of n integers a1, a2, ..., an (0 ≤ ai ≤ 600) — participants' scores.

It's guaranteed that at least one participant has non-zero score.

Output

Print a single integer — the desired number of ways.

Examples
input
Copy
4
1 3 3 2
output
3
input
Copy
3
1 1 1
output
1
input
Copy
4
42 0 0 42
output
1
Note

There are three ways to choose a subset in sample case one.

  1. Only participants with 3 points will get diplomas.
  2. Participants with 2 or 3 points will get diplomas.
  3. Everyone will get a diploma!

The only option in sample case two is to award everyone.

Note that in sample case three participants with zero scores cannot get anything.

→ Source
#include<bits/stdc++.h>
using namespace std;
bool b[605]={true};
int n,ans;
int main(){
	cin>>n;
	for(int i=1;i<=n;++i){
		int x;cin>>x;
		if(!b[x])	b[x]=true,ans++;
	}
	cout<<ans;
	return 0;
}


B. Vile Grasshoppers
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

The weather is fine today and hence it's high time to climb the nearby pine and enjoy the landscape.

The pine's trunk includes several branches, located one above another and numbered from 2 to y. Some of them (more precise, from 2to p) are occupied by tiny vile grasshoppers which you're at war with. These grasshoppers are known for their awesome jumping skills: the grasshopper at branch x can jump to branches .

Keeping this in mind, you wisely decided to choose such a branch that none of the grasshoppers could interrupt you. At the same time you wanna settle as high as possible since the view from up there is simply breathtaking.

In other words, your goal is to find the highest branch that cannot be reached by any of the grasshoppers or report that it's impossible.

Input

The only line contains two integers p and y (2 ≤ p ≤ y ≤ 109).

Output

Output the number of the highest suitable branch. If there are none, print -1 instead.

Examples
input
Copy
3 6
output
5
input
Copy
3 4
output
-1
Note

In the first sample case grasshopper from branch 2 reaches branches 24 and 6 while branch 3 is initially settled by another grasshopper. Therefore the answer is 5.

It immediately follows that there are no valid branches in second sample case.

→ Source
#include<bits/stdc++.h>
using namespace std;
int p,y;
inline bool check(int x){
	for(int i=2;i<=p && 1ll*i*i<=x;++i)
		if(x%i==0)	return false;
	return true;
}
int main(){
	scanf("%d%d",&p,&y);
	for(int i=y;i>p;--i){
		if(check(i)){
			printf("%d",i);
			return 0;
		}
	}
	printf("-1");
	return 0;
}


C. Save Energy!
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Julia is going to cook a chicken in the kitchen of her dormitory. To save energy, the stove in the kitchen automatically turns off after kminutes after turning on.

During cooking, Julia goes to the kitchen every d minutes and turns on the stove if it is turned off. While the cooker is turned off, it stays warm. The stove switches on and off instantly.

It is known that the chicken needs t minutes to be cooked on the stove, if it is turned on, and 2t minutes, if it is turned off. You need to find out, how much time will Julia have to cook the chicken, if it is considered that the chicken is cooked evenly, with constant speed when the stove is turned on and at a constant speed when it is turned off.

Input

The single line contains three integers kd and t (1 ≤ k, d, t ≤ 1018).

Output

Print a single number, the total time of cooking in minutes. The relative or absolute error must not exceed 10 - 9.

Namely, let's assume that your answer is x and the answer of the jury is y. The checker program will consider your answer correct if .

Examples
input
Copy
3 2 6
output
6.5
input
Copy
4 2 20
output
20.0
Note

In the first example, the chicken will be cooked for 3 minutes on the turned on stove, after this it will be cooked for . Then the chicken will be cooked for one minute on a turned off stove, it will be cooked for . Thus, after four minutes the chicken will be cooked for . Before the fifth minute Julia will turn on the stove and after 2.5 minutes the chicken will be ready .

In the second example, when the stove is turned off, Julia will immediately turn it on, so the stove will always be turned on and the chicken will be cooked in 20 minutes.

→ Source
#include<bits/stdc++.h>
using namespace std;
long long k,d,t,p,n,m;
long double ans,c1,c2;
int main(){
	cin>>k>>d>>t;
	p=k%d;		n=k/d*d+p;		m=(d-p)%d;
	c1=((long double)n)/t;
	c2=((long double)m)/2/t;
	long long num=floor(1.0/(c1+c2));
	ans=num*(n+m);
	long double res=1.0-num*(c1+c2);
	if(c1>=res)	ans+=res*t;
	else{
		res-=c1;
		ans+=c1*t;
		ans+=res*2*t;
	}
	printf("%.25lf",(double)ans);
	return 0;
}


D. Sleepy Game
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Petya and Vasya arranged a game. The game runs by the following rules. Players have a directed graph consisting of n vertices and medges. One of the vertices contains a chip. Initially the chip is located at vertex s. Players take turns moving the chip along some edge of the graph. Petya goes first. Player who can't move the chip loses. If the game lasts for 106 turns the draw is announced.

Vasya was performing big laboratory work in "Spelling and parts of speech" at night before the game, so he fell asleep at the very beginning of the game. Petya decided to take the advantage of this situation and make both Petya's and Vasya's moves.

Your task is to help Petya find out if he can win the game or at least draw a tie.

Input

The first line of input contain two integers n and m — the number of vertices and the number of edges in the graph (2 ≤ n ≤ 105,0 ≤ m ≤ 2·105).

The next n lines contain the information about edges of the graph. i-th line (1 ≤ i ≤ n) contains nonnegative integer ci — number of vertices such that there is an edge from i to these vertices and ci distinct integers ai, j — indices of these vertices (1 ≤ ai, j ≤ nai, j ≠ i).

It is guaranteed that the total sum of ci equals to m.

The next line contains index of vertex s — the initial position of the chip (1 ≤ s ≤ n).

Output

If Petya can win print «Win» in the first line. In the next line print numbers v1, v2, ..., vk (1 ≤ k ≤ 106) — the sequence of vertices Petya should visit for the winning. Vertex v1 should coincide with s. For i = 1... k - 1 there should be an edge from vi to vi + 1 in the graph. There must be no possible move from vertex vk. The sequence should be such that Petya wins the game.

If Petya can't win but can draw a tie, print «Draw» in the only line. Otherwise print «Lose».

Examples
input
Copy
5 6
2 2 3
2 4 5
1 4
1 5
0
1
output
Win
1 2 4 5 
input
Copy
3 2
1 3
1 1
0
2
output
Lose
input
Copy
2 2
1 2
1 1
1
output
Draw
Note

In the first example the graph is the following:

Initially the chip is located at vertex 1. In the first move Petya moves the chip to vertex 2, after that he moves it to vertex 4 for Vasya. After that he moves to vertex 5. Now it is Vasya's turn and there is no possible move, so Petya wins.

In the second example the graph is the following:

Initially the chip is located at vertex 2. The only possible Petya's move is to go to vertex 1. After that he has to go to 3 for Vasya. Now it's Petya's turn but he has no possible move, so Petya loses.

In the third example the graph is the following:

Petya can't win, but he can move along the cycle, so the players will draw a tie.

→ Source
#include<bits/stdc++.h>
#define N 100050
#define M 200050
#define pa pair<int,int>
using namespace std;
int n,m,S,tim;
int head[N],degree[N],nex[M],to[M],tp;
int dfn[N],low[N],sta[N],cnt;
bool vis[N][2],in[N];
inline void add(int x,int y){
	nex[++tp]=head[x];
	head[x]=tp;
	to[tp]=y;
	++degree[x];
}
pa q[N*2];int hed=1,tail=0;
int pre[N*2];
int stac[2*N],top;
inline void print(int x){
	while(x){
		stac[++top]=q[x].first;
		x=pre[x];
	}
	while(top)	printf("%d ",stac[top--]);
}
void dfs(int x){
	dfn[x]=low[x]=++tim;sta[++cnt]=x;
	for(int i=head[x];i;i=nex[i]){
		if(in[to[i]])	continue;
		if(dfn[to[i]])	low[x]=min(low[x],dfn[to[i]]);
		else{
			dfs(to[i]);
			low[x]=min(low[x],low[to[i]]);
		}
	}
	if(dfn[x]==low[x]){
		int num=0;
		if(sta[cnt]!=x){
			printf("Draw");
			exit(0);
		}
		--cnt;in[x]=true;
	}
}
int main(){
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;++i){
		int tot;
		scanf("%d",&tot);
		while(tot--){
			int x;
			scanf("%d",&x);
			add(i,x);
		}
	}
	scanf("%d",&S);vis[S][0]=true;
	q[++tail]=pa(S,0);
	while(hed<=tail){
		int x=q[hed].first,y=q[hed].second;
		if(!degree[x] && y){
			printf("Win\n");
			print(hed);
			return 0;
		}
		for(int i=head[x];i;i=nex[i]){
			if(vis[to[i]][y^1])	continue;
			vis[to[i]][y^1]=true;
			q[++tail]=pa(to[i],y^1);
			pre[tail]=hed;
		}
		++hed;
	}
	dfs(S);
	printf("Lose");
	return 0;
}


E. Lock Puzzle
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Welcome to another task about breaking the code lock! Explorers Whitfield and Martin came across an unusual safe, inside of which, according to rumors, there are untold riches, among which one can find the solution of the problem of discrete logarithm!

Of course, there is a code lock is installed on the safe. The lock has a screen that displays a string of n lowercase Latin letters. Initially, the screen displays string s. Whitfield and Martin found out that the safe will open when string t will be displayed on the screen.

The string on the screen can be changed using the operation «shift x». In order to apply this operation, explorers choose an integer xfrom 0 to n inclusive. After that, the current string p = αβ changes to βRα, where the length of β is x, and the length of α is n - x. In other words, the suffix of the length x of string p is reversed and moved to the beginning of the string. For example, after the operation «shift 4» the string «abcacb» will be changed with string «bcacab », since α = abβ = cacbβR = bcac.

Explorers are afraid that if they apply too many operations «shift», the lock will be locked forever. They ask you to find a way to get the string t on the screen, using no more than 6100 operations.

Input

The first line contains an integer n, the length of the strings s and t (1 ≤ n ≤ 2 000).

After that, there are two strings s and t, consisting of n lowercase Latin letters each.

Output

If it is impossible to get string t from string s using no more than 6100 operations «shift», print a single number  - 1.

Otherwise, in the first line output the number of operations k (0 ≤ k ≤ 6100). In the next line output k numbers xi corresponding to the operations «shift xi» (0 ≤ xi ≤ n) in the order in which they should be applied.

Examples
input
Copy
6
abacbb
babcba
output
4
6 3 2 3
input
Copy
3
aba
bba
output
-1

In the first example, after applying the operations, the string on the screen will change as follows:

  1. abacbb  bbcaba
  2. bbcaba  ababbc
  3. ababbc  cbabab
  4. cbabab  babcba
→ Source
#include<bits/stdc++.h>
#define N 2005
using namespace std;
int n,Asum[N],Bsum[N],ans,an[3*N],tp;
char a[N],b[N],tmp[N];
inline void rev(int len){
	tp=0;
	for(int i=0;i<len;++i)	tmp[++tp]=a[n-i];
	for(int i=1;i<=n-len;++i)	tmp[++tp]=a[i];
	for(int i=1;i<=n;++i)	a[i]=tmp[i];
}
int main(){
	scanf("%d%s%s",&n,a+1,b+1);
	for(int i=1;i<=n;++i){
		++Asum[a[i]-'a'];
		++Bsum[b[i]-'a'];
	}
	for(int i=0;i<26;++i)
		if(Asum[i]!=Bsum[i]){
			printf("-1");
			return 0;
		}
	for(int i=1;i<=n;++i){
		int num;
		for(int j=1;j<=n;++j)
			if(a[j]==b[i])	{num=j;break;}
		an[++ans]=n-num;	rev(n-num);
		an[++ans]=1;		rev(1);
		an[++ans]=n;		rev(n);
	}
	printf("%d\n",ans);
	for(int i=1;i<=ans;++i)	printf("%d ",an[i]);
	return 0;
}



  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

zP1nG

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值